# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Media do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :MediaKey,
    :PreferredPhotoYN,
    :Deleted,
    :ChangedByMemberKeyNumeric,
    :ImageHeight,
    :ImageWidth,
    :MediaKeyNumeric,
    :Order,
    :ResourceRecordKeyNumeric,
    :Hash,
    :ChangedByMemberID,
    :ChangedByMemberKey,
    :LongDescription,
    :MediaHTML,
    :MediaObjectID,
    :MediaURL,
    :OriginatingSystemID,
    :OriginatingSystemMediaKey,
    :OriginatingSystemName,
    :ResourceRecordID,
    :ResourceRecordKey,
    :ShortDescription,
    :SourceSystemID,
    :SourceSystemMediaKey,
    :SourceSystemName,
    :Permission,
    :ClassName,
    :ImageOf,
    :ImageSizeDescription,
    :MediaCategory,
    :MediaStatus,
    :MediaType,
    :ResourceName,
    :ModificationTimestamp,
    :MediaModificationTimestamp,
    :updatedAt,
    :createdAt,
    :Labels,
    :Segmaps,
    :Trials
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :MediaKey => String.t | nil,
    :PreferredPhotoYN => boolean() | nil,
    :Deleted => boolean() | nil,
    :ChangedByMemberKeyNumeric => integer() | nil,
    :ImageHeight => integer() | nil,
    :ImageWidth => integer() | nil,
    :MediaKeyNumeric => integer() | nil,
    :Order => integer() | nil,
    :ResourceRecordKeyNumeric => integer() | nil,
    :Hash => String.t | nil,
    :ChangedByMemberID => String.t | nil,
    :ChangedByMemberKey => String.t | nil,
    :LongDescription => String.t | nil,
    :MediaHTML => String.t | nil,
    :MediaObjectID => String.t | nil,
    :MediaURL => String.t | nil,
    :OriginatingSystemID => String.t | nil,
    :OriginatingSystemMediaKey => String.t | nil,
    :OriginatingSystemName => String.t | nil,
    :ResourceRecordID => String.t | nil,
    :ResourceRecordKey => String.t | nil,
    :ShortDescription => String.t | nil,
    :SourceSystemID => String.t | nil,
    :SourceSystemMediaKey => String.t | nil,
    :SourceSystemName => String.t | nil,
    :Permission => [String.t] | nil,
    :ClassName => String.t | nil,
    :ImageOf => String.t | nil,
    :ImageSizeDescription => String.t | nil,
    :MediaCategory => String.t | nil,
    :MediaStatus => String.t | nil,
    :MediaType => String.t | nil,
    :ResourceName => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :MediaModificationTimestamp => Date.t | nil,
    :updatedAt => Date.t | nil,
    :createdAt => Date.t | nil,
    :Labels => [FoyerAPI.Model.Label.t] | nil,
    :Segmaps => [FoyerAPI.Model.Segmap.t] | nil,
    :Trials => [FoyerAPI.Model.Trial.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Media do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:MediaModificationTimestamp, :date, nil, options)
    |> deserialize(:updatedAt, :date, nil, options)
    |> deserialize(:createdAt, :date, nil, options)
    |> deserialize(:Labels, :list, FoyerAPI.Model.Label, options)
    |> deserialize(:Segmaps, :list, FoyerAPI.Model.Segmap, options)
    |> deserialize(:Trials, :list, FoyerAPI.Model.Trial, options)
  end
end

